#!/usr/bin/perl
# Save list of default features

require './server-manager-lib.pl';
&can_action_error(undef, "global");
&ReadParse();
&error_setup($text{'features_err'});
&error_if_cloudmin_replica();
&obtain_lock_anything();

if ($in{'def'}) {
	# Use automatic defaults
	delete($config{'defs'});
	}
else {
	# Use selected
	@features = split(/\0/, $in{'features'});
	@features || &error($text{'features_enone'});
	$config{'defs'} = join(" ", @features);
	}
&lock_file($module_config_file);
&save_module_config();
&unlock_file($module_config_file);
&webmin_log("features");
&redirect("");

